
#include "MacroPatternMatch.h"

#include "HROOTIOTFile.h"

#include "TMemFile.h"

#include "HROOTIOTMemFile.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TFILE_DEF_VIRT(TMemFile)
TDIRECTORYFILE_DEF_VIRT(TMemFile)
TDIRECTORY_DEF_VIRT(TMemFile)
TNAMED_DEF_VIRT(TMemFile)
TOBJECT_DEF_VIRT(TMemFile)
DELETABLE_DEF_VIRT(TMemFile)
TMEMFILE_DEF_VIRT(TMemFile)
TMEMFILE_DEF_NONVIRT(TMemFile)
TMEMFILE_DEF_ACCESSOR(TMemFile)

